function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? Object(arguments[i]) : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys.push.apply(ownKeys, Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
import * as React from 'react';
import I18nProvider from './I18nProvider';
import { I18n } from './i18nContext';
class I18nLoader extends React.Component {
  constructor() {
    var _this;
    super(...arguments);
    _this = this;
    _defineProperty(this, "state", {
      phrasesByLocale: {}
    });
    _defineProperty(this, "loadLocale", /*#__PURE__*/function () {
      var _ref = _asyncToGenerator(function* (locale) {
        var {
          loadPhrases
        } = _this.props;
        var phrases = yield loadPhrases(locale);
        _this.setState(state => ({
          phrasesByLocale: _objectSpread({}, state.phrasesByLocale, {
            [locale]: phrases
          })
        }));
      });
      return function (_x) {
        return _ref.apply(this, arguments);
      };
    }());
  }
  componentDidMount() {
    this.loadLocale(this.props.locale);
  }
  componentDidUpdate(prevProps) {
    var {
      phrasesByLocale
    } = this.state;
    // if language changed and we don't have it in state already, then load it
    if (this.props.locale !== prevProps.locale && !phrasesByLocale[this.props.locale]) {
      this.loadLocale(this.props.locale);
    }
  }
  render() {
    var {
      children,
      locale
    } = this.props;
    var {
      phrasesByLocale
    } = this.state;

    // Skip rendering when catalog isn't loaded.
    if (!phrasesByLocale[locale]) {
      return null;
    }
    return /*#__PURE__*/React.createElement(I18nProvider, {
      locale: locale,
      phrases: phrasesByLocale[locale]
    }, children);
  }
}
_defineProperty(I18nLoader, "defaultProps", {});
var I18nLoaderProvider = _ref2 => {
  var {
      locale
    } = _ref2,
    restProps = _objectWithoutProperties(_ref2, ["locale"]);
  return /*#__PURE__*/React.createElement(I18n, null, translator => {
    return /*#__PURE__*/React.createElement(I18nLoader, _extends({
      locale: locale || translator.locale()
    }, restProps));
  });
};
export default I18nLoaderProvider;